"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.destroy = exports.dispose = exports.create = void 0;
// eslint-disable-next-line import/no-extraneous-dependencies
const rdsdataservice_1 = __importDefault(require("aws-sdk/clients/rdsdataservice"));
const resolve_eventstore_base_1 = __importDefault(require("resolve-eventstore-base"));
const load_events_by_cursor_1 = __importDefault(require("./js/load-events-by-cursor"));
const load_events_by_timestamp_1 = __importDefault(require("./js/load-events-by-timestamp"));
const freeze_1 = __importDefault(require("./js/freeze"));
const unfreeze_1 = __importDefault(require("./js/unfreeze"));
const get_latest_event_1 = __importDefault(require("./js/get-latest-event"));
const save_event_1 = __importDefault(require("./js/save-event"));
const full_jitter_1 = __importDefault(require("./js/full-jitter"));
const execute_statement_1 = __importDefault(require("./js/execute-statement"));
const inject_event_1 = __importDefault(require("./js/inject-event"));
const coercer_1 = __importDefault(require("./js/coercer"));
const escape_id_1 = __importDefault(require("./js/escape-id"));
const escape_1 = __importDefault(require("./js/escape"));
const shape_event_1 = __importDefault(require("./js/shape-event"));
const load_snapshot_1 = __importDefault(require("./js/load-snapshot"));
const save_snapshot_1 = __importDefault(require("./js/save-snapshot"));
const drop_snapshot_1 = __importDefault(require("./js/drop-snapshot"));
const connect_1 = __importDefault(require("./connect"));
const init_1 = __importDefault(require("./init"));
const drop_1 = __importDefault(require("./drop"));
const dispose_1 = __importDefault(require("./dispose"));
const secrets_manager_1 = __importDefault(require("./secrets-manager"));
const create_1 = __importDefault(require("./resource/create"));
const dispose_2 = __importDefault(require("./resource/dispose"));
const destroy_1 = __importDefault(require("./resource/destroy"));
const createAdapter = resolve_eventstore_base_1.default.bind(null, {
    connect: connect_1.default,
    loadEventsByCursor: load_events_by_cursor_1.default,
    loadEventsByTimestamp: load_events_by_timestamp_1.default,
    getLatestEvent: get_latest_event_1.default,
    saveEvent: save_event_1.default,
    init: init_1.default,
    drop: drop_1.default,
    dispose: dispose_1.default,
    freeze: freeze_1.default,
    unfreeze: unfreeze_1.default,
    RDSDataService: rdsdataservice_1.default,
    escapeId: escape_id_1.default,
    escape: escape_1.default,
    fullJitter: full_jitter_1.default,
    executeStatement: execute_statement_1.default,
    injectEvent: inject_event_1.default,
    coercer: coercer_1.default,
    shapeEvent: shape_event_1.default,
    getSecretsManager: secrets_manager_1.default,
    loadSnapshot: load_snapshot_1.default,
    saveSnapshot: save_snapshot_1.default,
    dropSnapshot: drop_snapshot_1.default
});
exports.default = createAdapter;
const cloudPool = {
    executeStatement: execute_statement_1.default,
    connect: connect_1.default,
    RDSDataService: rdsdataservice_1.default,
    escapeId: escape_id_1.default,
    escape: escape_1.default,
    fullJitter: full_jitter_1.default,
    coercer: coercer_1.default,
    dispose: dispose_1.default,
    shapeEvent: shape_event_1.default
};
const createResource = create_1.default.bind(null, cloudPool);
exports.create = createResource;
const disposeResource = dispose_2.default.bind(null, cloudPool);
exports.dispose = disposeResource;
const destroyResource = destroy_1.default.bind(null, cloudPool);
exports.destroy = destroyResource;
Object.assign(cloudPool, {
    createResource,
    disposeResource,
    destroyResource
});
