"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("./constants");
const loadSnapshot = async (pool, snapshotKey) => {
    const { databaseName, snapshotsTableName, executeStatement, escapeId, escape } = pool;
    if (snapshotKey == null || snapshotKey.constructor !== String) {
        throw new Error('Snapshot key must be string');
    }
    const databaseNameAsId = escapeId(databaseName);
    const snapshotsTableNameAsId = escapeId(snapshotsTableName);
    let result = null;
    for (let index = 0;; index++) {
        const rows = await executeStatement(`SELECT substring("snapshotContent" from ${index * constants_1.LOAD_CHUNK_SIZE +
            1} for ${constants_1.LOAD_CHUNK_SIZE})
      AS "SnapshotContentChunk"
      FROM ${databaseNameAsId}.${snapshotsTableNameAsId}
      WHERE "snapshotKey" = ${escape(snapshotKey)} 
      LIMIT 1`);
        const content = rows.length > 0 ? rows[0].SnapshotContentChunk : null;
        if (content == null) {
            break;
        }
        else if (content != null && result == null) {
            result = '';
        }
        result += content;
        if (content.length < constants_1.LOAD_CHUNK_SIZE) {
            break;
        }
    }
    return result;
};
exports.default = loadSnapshot;
